#!/usr/bin/perl -I.

require 'ora_opcl.cgi'; # Common CGI file
require 'ora_user.cgi';
require 'ora_wrank.cgi';


&output_start;


$table   = "ora_user";     
$tableC  = "ora_wrank";     
@read_body = ();

# Connect to database
($dbh, $errstr) = openOracleConnection();
if( !$dbh )
{
    output("Error connecting to database: $errstr<br>");
    exit(0);
}

# Create New table into DataBase
 output("Create New tables: $table AND $tableC<br>");
($errN, $errstr) = create_User($dbh, $table);
 print "Error: $errN .... $errstr<br>" if $errN;
($errN, $errstr) = create_WRank($dbh, $tableC);
 print "Error: $errN .... $errstr<br>" if $errN;

# Insert new row into table
 output("");
 output("Fill User Table: $table<br><br>");
    $uname  = "Alex";      # User name
    $b_d = retBirthDaySec(4, 1, 1963); # April/01/1963
    ($errN, $errstr) = insertRow_User( $dbh, $table, "MK51000   ", "AV\@email.com", $uname, "SF", "CA", "US", "Y", $bin_body1, $b_d, "Y", "N", "P1\@email.com", "", time, time  );
    print "Error: $errN .... $errstr<br>" if $errN;
    ($errN, $errstr, $UK1) = getUK_UserByEmail( $dbh, $table, "AV\@email.com" );
 output("Insert Row1 into $table  AND get UniqKey: $UK1<br>");
# Insert new row into table
    $uname  = "Guennadi";  # User name
    $b_d = retBirthDaySec(12, 12, 1960); # December/12/1960
    ($errN, $errstr) = insertRow_User( $dbh, $table, "MK51000   ", "GN\@email.com", $uname, "Mountain View", "CA", "US", "Y", $bin_body2, $b_d, "Y", "Y", "P1\@email.com", "", time, time );
    print "Error: $errN .... $errstr<br>" if $errN;
    ($errN, $errstr, $UK2) = getUK_UserByEmail( $dbh, $table, "GN\@email.com" );
 output("Insert Row2 into $table  AND get UniqKey: $UK2<br>");
# Insert new row into table
    $uname  = "Tom";       # User name
    $b_d = retBirthDaySec(12, 28, 1956); # December/28/1956
    ($errN, $errstr) = insertRow_User( $dbh, $table, "MK51000   ", "TR\@email.com", $uname, "SF", "CA", "US", "Y", $bin_body3, $b_d, "N", "N", "", "P2\@email.com", time, time );
    print "Error: $errN .... $errstr<br>" if $errN;
    ($errN, $errstr, $UK3) = getUK_UserByEmail( $dbh, $table, "TR\@email.com" );
 output("Insert Row2 into $table  AND get UniqKey: $UK3<br>");

 output("");
 output("Fill WRank Table: $tableC<br><br>");

    ($errN, $errstr) = insertRow_WRank( $dbh, $tableC, $UK1, 2111, 1, "St1", "Char1", 111, 4000, "Com1", time );
    print "Error: $errN .... $errstr<br>" if $errN;
 output("Insert Row1 into $tableC<br>");
	sleep(2);
    ($errN, $errstr) = insertRow_WRank( $dbh, $tableC, $UK1, 1111, 1, "St1", "Char1", 111, 6010, "Com1", time );
    print "Error: $errN .... $errstr<br>" if $errN;
 output("Insert Row1.1 into $tableC<br>");
	sleep(2);
    ($errN, $errstr) = insertRow_WRank( $dbh, $tableC, $UK2, 1000, 2, "St2", "Char2", 22, 9000, "Com2", time );
    print "Error: $errN .... $errstr<br>" if $errN;

 output("Insert Row2 into $tableC<br>");
	sleep(2);
    ($errN, $errstr) = insertRow_WRank( $dbh, $tableC, $UK2, 1000, 2, "St2", "Char2", 22, 3000, "Com2", time );
    print "Error: $errN .... $errstr<br>" if $errN;
 output("Insert Row2.1 into $tableC<br>");
	sleep(2);
    ($errN, $errstr) = insertRow_WRank( $dbh, $tableC, $UK3, 1000, 3, "St3", "Char3",  111, 5000, "Com3", time );
    print "Error: $errN .... $errstr<br>" if $errN;

 output("Insert Row3 into $tableC<br>");
	sleep(2);
    ($errN, $errstr) = insertRow_WRank( $dbh, $tableC, $UK3, 3111, 3, "St3", "Char3",  3, 1000, "Com3", time );
    print "Error: $errN .... $errstr<br>" if $errN;
 output("Insert Row3.1 into $tableC<br>");

# List of all records into WRank table
 output("");
 output("Show all Rows from $tableC");
    ($errN, $errstr, $sth) = selectAllRows_WRank( $dbh, $tableC );
    print "Select Error: $errN .... $errstr<br>" if $errN;

    $j = 1;
    while( (@row) = getNextRow_WRank($sth) )
    {
        prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
    }

# Select Row
 output("");
 output("");

	sleep(2);
 output("Show Row for EVENT 1000 FOR current Date and Time - 7 secs");
    ($errN, $errstr, $sth) = getRow_WRankByEVENTandTime( $dbh, $tableC, 1000, 7 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_WRank($sth) )
    {
       prepareRowToPrint();
       output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
    }
 output("");
 output("Show Row FROM: $tableC BY UniqKey: $UK3<br><br>");
    ($errN, $errstr, $sth) = getRow_WRankByUK( $dbh, $tableC, $UK3 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_WRank($sth) )
    {
       prepareRowToPrint();
       output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
    }
 output("");
 output("Show Row FROM: $tableC BY UniqKey: $UK3   AND Event 3111<br><br>");
    ($errN, $errstr, @row) = getRow_WRankByUKandEVENT( $dbh, $tableC, $UK3, 3111 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    prepareRowToPrint();
    output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));

 output("");
 output("Show Row FROM: $tableC BY Event: 1000   AND ORDERED BY Value(ascending) for last 10 secs");
    ($errN, $errstr, $sth) = getRow_WRankByEvent( $dbh, $tableC, 1000, "ASC", 10 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_WRank($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
    }
 output("Show Row FROM: $tableC BY Event: 1000   AND ORDERED BY Value(ascending) for last 8 secs");
    ($errN, $errstr, $sth) = getRow_WRankByEvent( $dbh, $tableC, 1000, "ASC", 8 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_WRank($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
    }
 output("Show Row FROM: $tableC BY Event: 1000   AND ORDERED BY Value(descending) for last 7 secs");
    ($errN, $errstr, $sth) = getRow_WRankByEvent( $dbh, $tableC, 1000, "DESC", 7 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_WRank($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
    }

 output("Show Row FROM: $tableC BY Event: 1000   AND ORDERED BY FishType(descending) AND Value(ascending) for last 7 secs");
    ($errN, $errstr, $sth) = getRow_WRankByEVENTandFTYPE( $dbh, $tableC, 1000, 7 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_WRank($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
    }
 output("Show Row FROM: $tableC BY Event: 1000   AND ORDERED BY FishType(descending) AND Value(ascending) for last 60 secs");
    ($errN, $errstr, $sth) = getRow_WRankByEVENTandFTYPE( $dbh, $tableC, 1000, 60 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_WRank($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
    }


# Delete Row
 output("");
 output("Delete $UK2 Row FROM: $tableC and Show All Rows<br><br>");
    ($errN, $errstr)       = deleteRow_WRankByUK( $dbh, $tableC, $UK2 );
    ($errN, $errstr, $sth) = selectAllRows_WRank( $dbh, $tableC );
    print "Select Error: $errN .... $errstr<br>" if $errN;

    while( (@row) = getNextRow_WRank($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
    }

 output("");
 output("Delete $UK3 AND Event 3111 Row FROM: $tableC and Show All Rows<br><br>");
    ($errN, $errstr)       = deleteRow_WRankByUKandEVENT( $dbh, $tableC, $UK3, 3111 );
    ($errN, $errstr, $sth) = selectAllRows_WRank( $dbh, $tableC );
    print "Select Error: $errN .... $errstr<br>" if $errN;

    while( (@row) = getNextRow_WRank($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
    }


# Modify Row
 output("");
 output("Modify $UK3 AND Event 3000 Row FROM: $tableC and Show All Rows<br><br>");
    ($errN, $errstr)       = modifyRow_WRankByUKandEVENT( $dbh, $tableC, $UK3, 3000, 9, "-3-", "Char3",  3, 9999, "Com3.1", time );
    ($errN, $errstr, $sth) = selectAllRows_WRank( $dbh, $tableC );
    print "Select Error: $errN .... $errstr<br>" if $errN;

    while( (@row) = getNextRow_WRank($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
    }





# Delete Tables from DataBase
output("<hr><br>");
output("Delete TableS: $table AND $tableC<br>");
($errN, $errstr) = delete_User($dbh, $table);
print "Error: $errN .... $errstr<br>" if $errN;
($errN, $errstr) = delete_WRank($dbh, $tableC);
print "Error: $errN .... $errstr<br>" if $errN;



closeOracleConnection( $dbh );

output("Finish<br>");
&output_end;

#---------------------------------------------------
# Output Forms
#---------------------------------------------------
#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub output {

my($outstr) = @_;
    print $outstr, "\r\n";
}

sub output_start {

    print <<EOF;
Content-type: text/html

<html>
<head>
<title>Result</title>
</head>
EOF

}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub output_end {

    print <<EOF;
</body>
</html>
EOF

}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
# MethGet
# Return true if this cgi call was using the GET request, false otherwise
sub MethGet 
{
  return ($ENV{'REQUEST_METHOD'} eq "GET");
}


#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
# MethPost
# Return true if this cgi call was using the POST request, false otherwise
sub MethPost 
{
  return ($ENV{'REQUEST_METHOD'} eq "POST");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub ReadParse 
{
  local (*in) = @_;
  local ($i, $key, $val);

  if (&MethGet) 
  {
    $in = $ENV{'QUERY_STRING'};
  } 
  elsif (&MethPost) 
  {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }
  else
  {
      print "</p></p><p align='left'>Unrecognize metod</a></p>";
      exit(0);
  }

  @in = split(/[&;]/,$in); 

  $cycle = 0;
  foreach $i (0 .. $#in) 
  {
    # Convert plus's to spaces
    $in[$i] =~ s/\+/ /g;

    # Split into key and value.  
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

    # Convert %XX from hex numbers to alphanumeric
    $key =~ s/%(..)/pack("c",hex($1))/ge;
#    $val =~ s/%(..)/pack("c",hex($1))/ge;

    # Associate key and value
    $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
    $in{$key} .= $val;
	$cycle++;

  }

  return ($cycle);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub retBirthDaySec
{
my($mm, $dd, $yy) = @_;
my(@dmon) = ();
my($ny, $i, $days);

$dmon[0] = 0;
$dmon[1] = 31;
$dmon[2] = 28;
$dmon[3] = 31;
$dmon[4] = 30;
$dmon[5] = 31;
$dmon[6] = 30;
$dmon[7] = 31;
$dmon[8] = 31;
$dmon[9] = 30;
$dmon[10] = 31;
$dmon[11] = 30;
$dmon[12] = 31;

	$ny = ($yy % 4 );
	if($ny == 0)
	{
		$ny = $dmon[$mm] + 1;
	}
	else
	{
		$ny = $dmon[$mm];
	}

	$days = 0;
	for($i = 1900; $i < $yy; $i++)
	{
		$ny = ($i % 4 );
		if($ny == 0)
		{
			$days += 366;
		}
		else
		{
			$days += 365;
		}
	}
	$ny = ($yy % 4 );
	for($i = 1; $i < $mm; $i++)
	{
		$days += $dmon[$i];
		if($i == 2 && $ny == 0)
		{
			$days += 1;
		}
	}

	$days += $dd;
	return($days * 86400);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub  prepareRowToPrint
{
        $len = @row;
        for($i=0; $i < $len; $i++)
        {
            if( $i == $len-1)
		{
			($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($row[$i]);
			$mon++;
			$year = ($year < 20) ? $year+2000 : $year+1900;
			$rowN[$i] = sprintf ("%04d/%02d/%02d %02d:%02d:%02d",$year,$mon,$mday,$hour,$min,$sec);
		}
		else
		{
			$rowN[$i] = $row[$i];
		}
        }
}

