#!/usr/bin/perl -I..

use strict;

use CGI;
use	DC;
use DB;

use vars	(	'$dc',	# DC object
				'$errorURL',
			);

#...............................................

	my $q = new CGI;
	my ($dbh, $errN, $errstr);
	my $table = "";
	$dc = new DC($q);
	$errorURL = "cgi-bin/jetsetradio/admin/showhtml.cgi?page=admin_create.html";

	print $dc->q->header, $dc->q->start_html('Initialize Tables');

	my $mode = $dc->q->param('mode');
	my $table = $dc->q->param('table');

	($dbh, $errstr) = DB::openOracleConnection();
	if( !$dbh )
	{
		$dc->error("[admin] Error connecting to database: $errstr", $errorURL);
	}
	
	if ($table eq 'user')
	{
		# Create New table into DataBase
		$table = $dc->DBaseTable('USER');
		if ($mode eq 'create')
		{
			print "Create New User table: $table<br>\n";
			($errN, $errstr) = DB::create_User( $dbh, $table );
		}
		else
		{
			print "Delete User table: $table<br>\n";
			($errN, $errstr) = DB::delete_User( $dbh, $table );
		}
		if ($errN)
		{
			$dc->error("[admin] Unable to $mode User Table: $errN .... $errstr", $errorURL);
		}
	}
	elsif ($table eq 'wrank')
	{
		# Delete table from DataBase
		$table = $dc->DBaseTable('WRANK');
		if ($mode eq 'create')
		{
			print "Create New WRank table: $table<br>\n";
			($errN, $errstr) = DB::create_WRank( $dbh, $table );
		}
		else
		{
			print "Delete WRank table: $table<br>\n";
			($errN, $errstr) = DB::delete_WRank( $dbh, $table );
		}
		if ($errN)
		{
			$dc->error("[admin] Unable to $mode WRank Table: $errN .... $errstr", $errorURL);
		}
	}
	elsif ($table eq 'graffiti')
	{
		# Delete table from DataBase
		$table = $dc->DBaseTable('GRAFFITI');
		if ($mode eq 'create')
		{
			print "Create New Graffiti table: $table<br>\n";
			($errN, $errstr) = DB::create_Graffiti( $dbh, $table );
		}
		else
		{
			print "Delete WRank table: $table<br>\n";
			($errN, $errstr) = DB::delete_Graffiti( $dbh, $table );
		}
		if ($errN)
		{
			$dc->error("[admin] Unable to $mode Graffiti Table: $errN .... $errstr", $errorURL);
		}
	}
	
	DB::closeOracleConnection( $dbh );

	print $dc->q->a({-href=>'/cgi-bin/jetsetradio/admin/showhtml.cgi?page=admin_create.html'}, "Back");

	print $dc->q->end_html;
exit(0);


