#!/usr/bin/perl -I.

require 'ora_opcl.cgi'; # Common CGI file
require 'ora_user.cgi';
require 'ora_graffiti.cgi';


&output_start;


$table   = "ora_user";     
$tableC  = "ora_graffiti";     
@read_body = ();

$nmbOfBinColumeForLongTable = 14;

# Open and read test bin files
   $bin_body1 = readBinFile("./stress.jpg");

# Connect to database
($dbh, $errstr) = openOracleConnection();
if( !$dbh )
{
    output("Error connecting to database: $errstr<br>");
    exit(0);
}


# Create New table into DataBase
 output("Create New tables: $table AND $tableC<br>");
($errN, $errstr) = create_User($dbh, $table);
 print "Error: Creating User Table $errN .... $errstr<br>" if $errN;
($errN, $errstr) = create_Graffiti($dbh, $tableC);
 print "Error: Creating Graffiti Table $errN .... $errstr<br>" if $errN;

# Insert new row into table
 output("<HR><BR>\n");
 output("Fill User Table: $table<br><br>");
    $uname  = "Alex";      # User name
    ($errN, $errstr) = insertRow_User( $dbh, $table, "10", "AV\@email.com", $uname, "SF", "CA", "US", "Y", "Y", 22, 333, 44, 5, time, time  );
    print "Error: $errN .... $errstr<br>" if $errN;
    ($errN, $errstr, $UK1) = getUK_UserByEmail( $dbh, $table, "AV\@email.com" );
 output("Insert Row1 into $table  AND get UniqKey: $UK1<br>");
# Insert new row into table
    $uname  = "Guennadi";  # User name
    ($errN, $errstr) = insertRow_User( $dbh, $table, "20", "GN\@email.com", $uname, "Mountain View", "CA", "US", "Y", "N", 22, 333, 44, 5, time, time );
    print "Error: $errN .... $errstr<br>" if $errN;
    ($errN, $errstr, $UK2) = getUK_UserByEmail( $dbh, $table, "GN\@email.com" );
 output("Insert Row2 into $table  AND get UniqKey: $UK2<br>");
# Insert new row into table
    $uname  = "Tom";       # User name
    ($errN, $errstr) = insertRow_User( $dbh, $table, "30", "TR\@email.com", $uname, "SF", "CA", "US", "Y", "Y", 22, 333, 44, 5, time, time );
    print "Error: $errN .... $errstr<br>" if $errN;
    ($errN, $errstr, $UK3) = getUK_UserByEmail( $dbh, $table, "TR\@email.com" );
 output("Insert Row2 into $table  AND get UniqKey: $UK3<br>");

 output("<HR><BR>\n");
 output("Fill Graffiti Table: $tableC<br><br>");

    ($errN, $errstr) = insertRow_Graffiti( $dbh, $tableC, $UK1, 0, "Piece1", "Cool Graffiti", "Com1", 3000, 10, 2, 5.0, "N", $UK1, time, time, $bin_body1 );
    print "Error: $errN .... $errstr<br>" if $errN;
 output("Insert Row1 into $tableC<br>");
	sleep(2);
    ($errN, $errstr) = insertRow_Graffiti( $dbh, $tableC, $UK1, 0, "Piece2", "1234567890123456", "Com1", 3000, 5, 2, 2.5, "Y", $UK1, time, time, $bin_body1 );
    print "Error: $errN .... $errstr<br>" if $errN;
 output("Insert Row1.1 into $tableC<br>");
	sleep(2);
    ($errN, $errstr) = insertRow_Graffiti( $dbh, $tableC, $UK1, 0, "Piece3", "Rock'n It!", "Com1", 10, 1, 2, 0.2, "Y", $UK1, time, time, $bin_body1 );
    print "Error: $errN .... $errstr<br>" if $errN;
 output("Insert Row1.2 into $tableC<br>");

	sleep(2);
    ($errN, $errstr) = insertRow_Graffiti( $dbh, $tableC, $UK2, 1, "Evil", "The Darkness", "Com2", 2000, 1, 3, 2.3, "N", $UK1, time, time, $bin_body1 );
    print "Error: $errN .... $errstr<br>" if $errN;
 output("Insert Row2 into $tableC<br>");
	sleep(2);
    ($errN, $errstr) = insertRow_Graffiti( $dbh, $tableC, $UK2, 1, "Blue", "The skys of life", "Com2", 450, 11, 3, 1.3, "Y", $UK1, time, time, $bin_body1 );
    print "Error: $errN .... $errstr<br>" if $errN;
 output("Insert Row2.1 into $tableC<br>");
	sleep(2);
    ($errN, $errstr) = insertRow_Graffiti( $dbh, $tableC, $UK2, 1, "Title", "The world rules!", "Com2", 400, 33, 3, 3.9, "N", $UK1, time, time, $bin_body1 );
    print "Error: $errN .... $errstr<br>" if $errN;
 output("Insert Row2.2 into $tableC<br>");
	sleep(2);
    ($errN, $errstr) = insertRow_Graffiti( $dbh, $tableC, $UK3, 2, "Small", "Kick Ass!", "Com3", 100, 0, 10, 3.1, "N", $UK1, time, time, $bin_body1 );
    print "Error: $errN .... $errstr<br>" if $errN;

 output("Insert Row3 into $tableC<br>");
	sleep(2);
    ($errN, $errstr) = insertRow_Graffiti( $dbh, $tableC, $UK3, 2, "Piece4", "Cool Picture", "Com3", 10000, 0, 5, 1.6, "Y", $UK1, time, time, $bin_body1 );
    print "Error: $errN .... $errstr<br>" if $errN;
 output("Insert Row3.1 into $tableC<br>");

# Show Current and Next Unique Value
 output("<HR><BR>\n");

	($errN, $errstr, $count) = currval_Graffiti( $dbh );
    print "Currval Error: $errN .... $errstr<br>" if $errN;
	print "Current value = ".$count."<BR>";

	($errN, $errstr, $count) = nextval_Graffiti( $dbh );
    print "Nextval Error: $errN .... $errstr<br>" if $errN;
	print "Next value = ".$count."<BR>";

# List of all records into Graffiti table
 output("<HR><BR>\n");
 output("Show all Rows from $tableC -- BINARY PARTs ARE SAVED AS FILEs --- Long.jpg --- INTO WORKING DIRECTORY<br>");
    ($errN, $errstr, $sth) = selectAllRows_Graffiti( $dbh, $tableC );
    print "Select Error: $errN .... $errstr<br>" if $errN;

    while( (@row) = getNextRow_Graffiti($sth) )
    {
        prepareRowToPrint();
		if ($row[0] == 1)
		{
			$read_body = $row[$nmbOfBinColumeForLongTable];
		}
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }

# Open and write output bin files
    writeBinFile("/web/jetsetradio.web/tmp/Long.jpg", $read_body);

 output("<img src=\"/tmp/Long.jpg\">\n");

# Select Row
 output("<HR><BR>\n");
 output("<BR>\n");

 output("Show Row FROM: $tableC BY UniqKey: 2<br><br>\n");
    ($errN, $errstr, $sth) = getRow_GraffitiByUK( $dbh, $tableC, 2 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_Graffiti($sth) )
    {
       prepareRowToPrint();
       output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }

 output("<BR>\n");
	sleep(2);
 output("Show Row for SIZE = 2, Pending = 'Y', FOR current Date and Time - 7 secs<BR><BR>\n");
    ($errN, $errstr, $sth) = getRow_GraffitiBySize( $dbh, $tableC, 2, "N", "DESC", 7 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_Graffiti($sth) )
    {
       prepareRowToPrint();
       output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }
 output("<BR>\n");
 output("Show Row FROM: $tableC BY Size: 2 AND Pending='Y' ORDERED BY Title(ascending) for last 60 secs<br><br>\n");
    ($errN, $errstr, $sth) = getRow_GraffitiBySizeOrderbyTitle( $dbh, $tableC, 2, "Y", "ASC", 60 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_Graffiti($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }

 output("<BR>\n");
 output("Show Row FROM: $tableC BY Size: 2 AND Pending='Y' ORDERED BY Rank(ascending) for last 60 secs<br><br>\n");
    ($errN, $errstr, $sth) = getRow_GraffitiBySizeOrderbyRank( $dbh, $tableC, 2, "Y", "ASC", 60 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_Graffiti($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }

 output("<BR>\n");
 output("Show Row FROM: $tableC BY Size: 1 AND Pending='Y' ORDERED BY DLCount(descending) for last 30 secs<BR><BR>\n");
    ($errN, $errstr, $sth) = getRow_GraffitiByDLCountandSize( $dbh, $tableC, 1, 'Y', "DESC", 30 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_Graffiti($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }

 output("<BR>\n");
 output("Show Row FROM: $tableC BY Rank: BETWEEN 1.0 AND 3.9 AND Size=2 AND Pending='Y' ORDERED BY Title(descending) for last 20 secs<BR><BR>\n");
    ($errN, $errstr, $sth) = getRow_GraffitiByRankandSize( $dbh, $tableC, 1.0, 3.9, 2, 'Y', "DESC", 20 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_Graffiti($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }

 output("<BR>\n");
 output("Show Row FROM: $tableC BY User: $UK1 AND Size: 0 AND Pending='Y' AND ORDERED BY DateC(descending) for last 40 secs<BR><BR>\n");
    ($errN, $errstr, $sth) = getRow_GraffitiByUserIDandSize( $dbh, $tableC, $UK1, 0, 'Y', "DESC", 40 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_Graffiti($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }


 output("<BR>\n");
 output("Show Row FROM: $tableC BY Title: 'PIE' AND Size: 0 AND Pending='Y' AND ORDERED BY Title(descending) for last 60 secs<BR><BR>\n");
    ($errN, $errstr, $sth) = getRow_GraffitiSearchTitleandSize( $dbh, $tableC, "PIE", 0, "Y", "DESC", 60 );
    print "Select Error: $errN .... $errstr<br>" if $errN;
    while( (@row) = getNextRow_Graffiti($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }

# Delete Row
 output("<HR><BR>\n");
 output("Delete UniqKey 5 Row FROM: $tableC and Show All Rows<br><br>");
    ($errN, $errstr)       = deleteRow_GraffitiByUK( $dbh, $tableC, 5 );
    ($errN, $errstr, $sth) = selectAllRows_Graffiti( $dbh, $tableC );
    print "Select Error: $errN .... $errstr<br>" if $errN;

    while( (@row) = getNextRow_Graffiti($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }


# Modify Row
 output("<HR><BR>\n");
 output("Modify UniqKey=1 Row FROM: $tableC and Show All Rows<br><br>");
    ($errN, $errstr)       = modifyRow_GraffitiByUK( $dbh, $tableC, 1, $UK3, 1, "Killer", "Bad Image", "New Comment", 9999, 20, 5, 4.0, "Y", $UK2, time, $bin_body1 );
    ($errN, $errstr, $sth) = selectAllRows_Graffiti( $dbh, $tableC );
    print "Select Error: $errN .... $errstr<br>" if $errN;

    while( (@row) = getNextRow_Graffiti($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }

# Modify Count
 output("<BR>\n");
 output("Modify Counts for UniqKey=4 Row FROM: $tableC and Show All Rows<br><br>");
    ($errN, $errstr)       = modifyCountRow_GraffitiByUK( $dbh, $tableC, 4, 2000, 100, 25, 2.3 );
    ($errN, $errstr, $sth) = selectAllRows_Graffiti( $dbh, $tableC );
    print "Select Error: $errN .... $errstr<br>" if $errN;

    while( (@row) = getNextRow_Graffiti($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }





# Delete Tables from DataBase
output("<hr><br>");
output("Delete TableS: $table AND $tableC<br>");
($errN, $errstr) = delete_User($dbh, $table);
print "Error: $errN .... $errstr<br>" if $errN;
($errN, $errstr) = delete_Graffiti($dbh, $tableC);
print "Error: $errN .... $errstr<br>" if $errN;



closeOracleConnection( $dbh );

output("Finish<br>");
&output_end;

#---------------------------------------------------
# Output Forms
#---------------------------------------------------
#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub output {

my($outstr) = @_;
    print $outstr, "\r\n";
}

sub output_start {

    print <<EOF;
Content-type: text/html

<html>
<head>
<title>Result</title>
</head>
EOF

}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub output_end {

    print <<EOF;
</body>
</html>
EOF

}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
# MethGet
# Return true if this cgi call was using the GET request, false otherwise
sub MethGet 
{
  return ($ENV{'REQUEST_METHOD'} eq "GET");
}


#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
# MethPost
# Return true if this cgi call was using the POST request, false otherwise
sub MethPost 
{
  return ($ENV{'REQUEST_METHOD'} eq "POST");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub ReadParse 
{
  local (*in) = @_;
  local ($i, $key, $val);

  if (&MethGet) 
  {
    $in = $ENV{'QUERY_STRING'};
  } 
  elsif (&MethPost) 
  {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }
  else
  {
      print "</p></p><p align='left'>Unrecognize metod</a></p>";
      exit(0);
  }

  @in = split(/[&;]/,$in); 

  $cycle = 0;
  foreach $i (0 .. $#in) 
  {
    # Convert plus's to spaces
    $in[$i] =~ s/\+/ /g;

    # Split into key and value.  
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

    # Convert %XX from hex numbers to alphanumeric
    $key =~ s/%(..)/pack("c",hex($1))/ge;
#    $val =~ s/%(..)/pack("c",hex($1))/ge;

    # Associate key and value
    $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
    $in{$key} .= $val;
	$cycle++;

  }

  return ($cycle);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub retBirthDaySec
{
my($mm, $dd, $yy) = @_;
my(@dmon) = ();
my($ny, $i, $days);

$dmon[0] = 0;
$dmon[1] = 31;
$dmon[2] = 28;
$dmon[3] = 31;
$dmon[4] = 30;
$dmon[5] = 31;
$dmon[6] = 30;
$dmon[7] = 31;
$dmon[8] = 31;
$dmon[9] = 30;
$dmon[10] = 31;
$dmon[11] = 30;
$dmon[12] = 31;

	$ny = ($yy % 4 );
	if($ny == 0)
	{
		$ny = $dmon[$mm] + 1;
	}
	else
	{
		$ny = $dmon[$mm];
	}

	$days = 0;
	for($i = 1900; $i < $yy; $i++)
	{
		$ny = ($i % 4 );
		if($ny == 0)
		{
			$days += 366;
		}
		else
		{
			$days += 365;
		}
	}
	$ny = ($yy % 4 );
	for($i = 1; $i < $mm; $i++)
	{
		$days += $dmon[$i];
		if($i == 2 && $ny == 0)
		{
			$days += 1;
		}
	}

	$days += $dd;
	return($days * 86400);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub  prepareRowToPrint
{
        $len = @row;
        for($i=0; $i < $len; $i++)
        {
            if (( $i == $len-2) || ($i == $len-3))
			{
				($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($row[$i]);
				$mon++;
				$year = ($year < 20) ? $year+2000 : $year+1900;
				$rowN[$i] = sprintf ("%04d/%02d/%02d %02d:%02d:%02d",$year,$mon,$mday,$hour,$min,$sec);
			}
            elsif($i == $nmbOfBinColumeForLongTable)
			{
				$rowN[$i] = "Binary data";
			}
			else
			{
				$rowN[$i] = $row[$i];
			}
        }
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub writeBinFile
{
my($bin_name, $read_body) = @_;
   if (open(FOO,">" . $bin_name))
   {
      binmode(FOO);
      print FOO $read_body;
      close(FOO);
		chmod(0666,$bin_name);
   }
   else
   {
      output("Can't open output file: $bin_name<br>");
   }
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub readBinFile
{
my($bin_name) = @_;
my($read_body);
  if (open(FIE,"<" . $bin_name))
  {
    binmode(FIE);
    ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat(FIE);
    read(FIE, $read_body, $size);
    close(FIE);
  }
  else
  {
    output("Can't open bin file: $bin_name<br>");
    return("");
  }
  return($read_body);
}
