#!/usr/bin/perl -I.

require 'ora_opcl.cgi'; # Common CGI file
require 'ora_user.cgi';

&output_start;


$table  = "ora_test";     
@ihref  = ();
@read_body = ();
@rowV = ();

# Connect to database
($dbh, $errstr) = openOracleConnection();
if( !$dbh )
{
    output("Error connecting to database: $errstr<br>");
    exit(0);
}

# Create New table into DataBase
 output("Create New table: $table<br>");
($errN, $errstr) = create_User($dbh, $table);
 print "Error: $errN .... $errstr<br>" if $errN;

# Insert new row into table
 output("<hr><br>");
 output("Insert Row1 into $table --- USER DATA<br>");
    $uname  = "Alex";      # User name
    $GoM = 22;
    $SiM = 333;
    $BrM = 44;
    $BlR = 5;
    ($errN, $errstr) = insertRow_User( $dbh, $table, "1", "AV\@email.com", $uname, "SF", "CA", "US", "Y", "N", $GoM, $SiM, $BrM, $BlR, time, time  );
    print "Error: $errN .... $errstr<br>" if $errN;
# Insert new row into table
 output("Insert Row2 into $table --- USER DATA<br>");
    $uname  = "Guennadi";  # User name
    ($errN, $errstr) = insertRow_User( $dbh, $table, "2", "GN\@email.com", $uname, "Mountain View", "CA", "US", "Y", "Y", $GoM, $SiM, $BrM, $BlR, time, time );
    print "Error: $errN .... $errstr<br>" if $errN;
# Insert new row into table
 output("Insert Row3 into $table --- USER DATA<br>");
    $uname  = "Tom";       # User name
    ($errN, $errstr) = insertRow_User( $dbh, $table, "3", "TR\@email.com", $uname, "SF", "CA", "US", "Y", "N", $GoM, $SiM, $BrM, $BlR, time, time );
    print "Error: $errN .... $errstr<br>" if $errN;
# Insert new row into table
 output("Insert Row24 into $table --- USER DATA<br>");
    $uname  = "Guennadi";  # User name
    ($errN, $errstr) = insertRow_User( $dbh, $table, "1234567890123456789012", "GN\@email.com", $uname, "Mountain View", "CA", "US", "Y", "Y", $GoM, $SiM, $BrM, $BlR, time, time );
    print "Error: $errN .... $errstr<br>" if $errN;

# List of all entries into table
 output("<hr><br>");
 output("<BR>\n");
 output("<BR>\n");
 output("Show all SELECTED Rows from $table<br>");
    ($errN, $errstr, $sth) = selectAllRows_User( $dbh, $table );
    print "Select Error: $errN .... $errstr<br>" if $errN;

    while( (@row) = getNextRow_User($sth) )
    {
        prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }

# Row for Guennadi into table
 output("<hr><br>");
 output("<BR>\n");
 output("<BR>\n");
 output("Show Rows FROM: $table BY EMAIL: GN\@email.com<br>");
    ($errN, $errstr, $GNUK) = getUK_UserByEmail( $dbh, $table, "GN\@email.com" );

    ($errN, $errstr, @row) = getRow_UserByUK( $dbh, $table, $GNUK );
    print "Select User Error: $errN .... $errstr<br>" if $errN;

    prepareRowToPrint();
    output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
	output("<BR>\n");

 output("<hr><br>");
 output("Show Rows FROM: $table BY NAME: Tom<br>");
    ($errN, $errstr, $GNUK) = getUK_UserByName( $dbh, $table, "Tom" );

    ($errN, $errstr, @row) = getRow_UserByUK( $dbh, $table, $GNUK );
    print "Select User Error: $errN .... $errstr<br>" if $errN;

    prepareRowToPrint();
    output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
	output("<BR>\n");

 output("<hr><br>");
    ($errN, $errstr, $AlexUK) = getUK_UserByEmail( $dbh, $table, "AV\@email.com" );
 output("Get UK for EMAIL: AV\@email.com AND Show Row FROM: $table BY UNIQUE KEY: $AlexUK <br>");
    ($errN, $errstr, @row) = getRow_UserByUK( $dbh, $table, $AlexUK );
    print "Select User Error: $errN .... $errstr<br>" if $errN;

    prepareRowToPrint();
    output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
	output("<BR>\n");

# Delete Tom
 output("<hr><br>");
 output("<BR>\n");
 output("<BR>\n");

    ($errN, $errstr, $TomUK) = getUK_UserByEmail( $dbh, $table, "TR\@email.com" );
 output("Delete Tom's Row BY UNIQUE KEY: $TomUK INTO: $table and Show All Rows<br>");
    ($errN, $errstr)       = deleteRow_UserByUK( $dbh, $table, $TomUK );
    ($errN, $errstr, $sth) = selectAllRows_User( $dbh, $table );
    print "Select Error: $errN .... $errstr<br>" if $errN;

    while( (@row) = getNextRow_User($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }


# Update Tom
 output("<hr><br>");
 output("<BR>\n");
 output("<BR>\n");
 output("Update Alex's Row INTO: $table and Show All Rows<br>");
 sleep(2);
    $medal = 555;
    $GoM = 44;
    $SiM = 3;
    $BrM = 22;
    $BlR = 111;
    ($errN, $errstr, $AlexUK) = getUK_UserByEmail( $dbh, $table, "AV\@email.com" );
    ($errN, $errstr)       = modifyRow_UserByUK( $dbh, $table, $AlexUK, "alex\@email.com", "Alexander Villagran", "San Francisco", "California", "United States", "Y", "Y", $GoM, $SiM, $BrM, $BlR, time );
    ($errN, $errstr, $sth) = selectAllRows_User( $dbh, $table );
    print "Select Error: $errN .... $errstr<br>" if $errN;

    while( (@row) = getNextRow_User($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }

# Clear Alex
 output("<hr><br>");
 output("<BR>\n");
 output("<BR>\n");
 output("Clear Guennadi's Row INTO: $table and Show All Rows<br>");
 sleep(2);
    ($errN, $errstr)       = clearRow_User( $dbh, $table, "1234567890123456789012" );
    ($errN, $errstr, $sth) = selectAllRows_User( $dbh, $table );
    print "Select Error: $errN .... $errstr<br>" if $errN;

    while( (@row) = getNextRow_User($sth) )
    {
	  prepareRowToPrint();
        output(join(", ", map {defined $_ ? $_ : "(null)"} @rowN));
		output("<BR>\n");
    }

# Delete Table from DataBase
output("<hr><br>");
output("Delete Table: $table<br>");
($errN, $errstr) = delete_User($dbh, $table);
print "Error: $errN .... $errstr<br>" if $errN;



closeOracleConnection( $dbh );

output("Finish<br>");
&output_end;

#---------------------------------------------------
# Output Forms
#---------------------------------------------------
#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub output {

my($outstr) = @_;
    print $outstr, "\r\n";
}

sub output_start {

    print <<EOF;
Content-type: text/html

<html>
<head>
<title>Result</title>
</head>
EOF

}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub output_end {

    print <<EOF;
</body>
</html>
EOF

}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
# MethGet
# Return true if this cgi call was using the GET request, false otherwise
sub MethGet 
{
  return ($ENV{'REQUEST_METHOD'} eq "GET");
}


#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
# MethPost
# Return true if this cgi call was using the POST request, false otherwise
sub MethPost 
{
  return ($ENV{'REQUEST_METHOD'} eq "POST");
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub ReadParse 
{
  local (*in) = @_;
  local ($i, $key, $val);

  if (&MethGet) 
  {
    $in = $ENV{'QUERY_STRING'};
  } 
  elsif (&MethPost) 
  {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }
  else
  {
      print "</p></p><p align='left'>Unrecognize metod</a></p>";
      exit(0);
  }

  @in = split(/[&;]/,$in); 

  $cycle = 0;
  foreach $i (0 .. $#in) 
  {
    # Convert plus's to spaces
    $in[$i] =~ s/\+/ /g;

    # Split into key and value.  
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

    # Convert %XX from hex numbers to alphanumeric
    $key =~ s/%(..)/pack("c",hex($1))/ge;
#    $val =~ s/%(..)/pack("c",hex($1))/ge;

    # Associate key and value
    $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
    $in{$key} .= $val;
	$cycle++;

  }

  return ($cycle);
}

#+-----------------------------------------------------+
#|                                                     |
#+-----------------------------------------------------+
sub  prepareRowToPrint
{
        $len = @row;
        for($i=0; $i < $len; $i++)
        {
            if( $i == $len-2 || $i == $len-1)
			{
				($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($row[$i]);
				$mon++;
				$rowN[$i] = sprintf ("%04d/%02d/%02d %02d:%02d:%02d",$year+1900,$mon,$mday,$hour,$min,$sec);
			}
			else
			{
				$rowN[$i] = $row[$i];
			}
        }
}
